declare default element namespace 'http://пф.рф/ЭТК/СЗВ-ТД/2017-10-08';
declare namespace УТ = "http://пф.рф/УТ/2017-08-21";
declare namespace АФ = "http://пф.рф/АФ/2018-12-07";
declare variable $document as document-node() external;
declare variable $root := $document/ЭДПФР;
declare variable $info:=$root/СЗВ-ТД;
declare function local:nodeIndex($nodes as node()*, $nodeToFind as node()) as xs:integer
{

				for $seq in (1 to count($nodes))
				return $seq[$nodes[$seq] is $nodeToFind]
			
};
declare function local:nodePosition($node as node()?) as node()
{

				element {xs:QName("Результат")}
				{
					let $prefixes := ()
					let $prefixes := for $s in in-scope-prefixes($root) return insert-before($prefixes, 1, $s)
					let $ns := ()
					let $ns := for $p in $prefixes return insert-before($ns, 1, concat('Q{', namespace-uri-for-prefix($p, $root), '}'))
					return local:replacePathWithPrefixes(path($node), $ns, $prefixes)
				}
			
};
declare function local:replacePathWithPrefixes($path as xs:string?, $namespaces as xs:string*, $prefixes as xs:string*) as xs:string?
{

				if (count($namespaces) > 0)
				   then local:replacePathWithPrefixes(
				   		replace($path, local:escape-for-regex($namespaces[1]), if (local:all-whitespace($prefixes[1])) then '' else concat($prefixes[1], ':')),
				          $namespaces[position() > 1],
				          $prefixes[position() > 1])
				   else $path
			
};
declare function local:escape-for-regex($arg as xs:string?) as xs:string
{

				replace($arg, '(\.|\[|\]|\\|\||\-|\^|\$|\?|\*|\+|\{|\}|\(|\))','\\$1')
			
};
declare function local:result($path as xs:string, $expected as xs:anyAtomicType, $objectName as xs:string, $objectValue as xs:anyAtomicType) as node()
{

				if ($path = '0') then
					element {xs:QName("Результат")}
					{
						$path
					}
				else
					element {xs:QName("Результат")}
					{
						element {xs:QName("ПутьДоЭлемента")}
						{
							$path
						},
						element {xs:QName("ОжидаемоеЗначение")}
						{
							$expected
						},
						element {xs:QName("Объект")}
						{
							element {xs:QName("Наименование")}
							{
								$objectName
							},
							element {xs:QName("Значение")}
							{
								$objectValue
							}
						}
					}
			
};
declare function local:all-whitespace($arg as xs:string?) as xs:boolean
{

				normalize-space($arg) = ''
			
};
declare function local:isEmpty($element) as xs:boolean
{

				local:all-whitespace(string($element))
			
};
declare function local:notExistsOrEmpty($element) as xs:boolean
{

				not(exists($element)) or local:isEmpty($element)
			
};
declare function local:existsAndNotEmpty($element) as xs:boolean
{

				exists($element) and not(local:isEmpty($element))
			
};
declare function local:getFIO($fio) as xs:string
{

				concat($fio/УТ:Фамилия, ' ', $fio/УТ:Имя, if (local:isEmpty($fio/УТ:Отчество)) then '' else concat(' ', $fio/УТ:Отчество))
			
};
declare function local:getResult($res as item()*) as item()*
{
if (exists($res)) then $res else local:result('0','','','')
};
<БлокПроверок ID="ЭТК.СЗВ-ТД.1" name="Блок проверок документов по форме 'Сведения о трудовой деятельности работников'">
<Проверка ID="1">
<Описание>'Дата передачи отчетной формы' не может быть позже текущей даты</Описание>
<РезультатЗапроса>
{
local:getResult(
					let $curdt := current-date()
					return if ($info/ДатаПередачи <= $curdt) then ()
					else local:result(
						local:nodePosition($info/ДатаПередачи),
						concat('Дата передачи отчетной формы ', $info/ДатаПередачи, ' позже текущей даты ', $curdt),
						'',
						'')
				)}
</РезультатЗапроса>
<КодРезультата>50</КодРезультата>
</Проверка>
<Проверка ID="2">
<Описание>'Дата мероприятия' не может быть позже текущей даты</Описание>
<РезультатЗапроса>
{
local:getResult(
					let $curdt := current-date()					
					for $td in $info/ТрудоваяДеятельность
						for $m in ($td/Мероприятие | $td/МероприятиеОтменяемое)							
							let $dt := if (exists($m/Дата)) then $m/Дата else $m/ДатаОтмены
							return if ($dt <= $curdt) then ()
							else local:result(
								local:nodePosition($dt),
								concat('Дата мероприятия (дата отмены мероприятия) ', $dt, ' позже текущей даты ', $curdt),
								'СНИЛС, ФИО',
								concat($td/УТ:СНИЛС, ', ', local:getFIO($td/УТ:ФИО)))
				)}
</РезультатЗапроса>
<КодРезультата>50</КодРезультата>
</Проверка>
<Проверка ID="3">
<Описание>'Дата мероприятия' не может быть позже 'Даты передачи отчетной формы'</Описание>
<РезультатЗапроса>
{
local:getResult(
					let $transferdt := $info/ДатаПередачи					
					for $td in $info/ТрудоваяДеятельность
						for $m in ($td/Мероприятие | $td/МероприятиеОтменяемое)							
							let $dt := if (exists($m/Дата)) then $m/Дата else $m/ДатаОтмены
							return if ($dt <= $transferdt) then ()
							else local:result(
								local:nodePosition($dt),
								concat('Дата мероприятия (дата отмены мероприятия) ', $dt, ' позже даты передачи отчетной формы ', $transferdt),
								'СНИЛС, ФИО',
								concat($td/УТ:СНИЛС, ', ', local:getFIO($td/УТ:ФИО)))
				)}
</РезультатЗапроса>
<КодРезультата>50</КодРезультата>
</Проверка>
<Проверка ID="4">
<Описание>Если указан период 'Дата с...Дата по', то 'Дата с' не может быть позже 'Даты по'</Описание>
<РезультатЗапроса>
{
local:getResult(					
					for $td in $info/ТрудоваяДеятельность
						for $m in $td/Мероприятие
						where local:existsAndNotEmpty($m/ДатаС) and local:existsAndNotEmpty($m/ДатаПо)
							return if ($m/ДатаС <= $m/ДатаПо) then ()
							else local:result(
								local:nodePosition($m),
								concat('«Дата с» ', $m/ДатаС, ' позже «даты по» ', $m/ДатаПо),
								'СНИЛС, ФИО',
								concat($td/УТ:СНИЛС, ', ', local:getFIO($td/УТ:ФИО)))
				)}
</РезультатЗапроса>
<КодРезультата>50</КодРезультата>
</Проверка>
<Проверка ID="5">
<Описание>Если вид мероприятия принимает значение 'Прием на работу', то должны быть обязательно заполнены 'Должность', 'Структурное подразделение'</Описание>
<РезультатЗапроса>
{
local:getResult(
					for $td in $info/ТрудоваяДеятельность
						for $m in $td/Мероприятие
						where $m/Вид = '1'
							return if (
									local:existsAndNotEmpty($m/Должность) 
								and local:existsAndNotEmpty($m/СтруктурноеПодразделение)
								) then ()
							else local:result(
								local:nodePosition($m),
								'Не заполнены «Должность», «Структурное подразделение»',
								'СНИЛС, ФИО',
								concat($td/УТ:СНИЛС, ', ', local:getFIO($td/УТ:ФИО)))
				)}
</РезультатЗапроса>
<КодРезультата>50</КодРезультата>
</Проверка>
<Проверка ID="6">
<Описание>Если вид мероприятия принимает значение 'Увольнение', то должны быть обязательно заполнены 'Сведения о мероприятии' и либо 'Номер статьи Трудового кодекса', либо указано 'Основание увольнения'. При этом если указано 'Основание увольнения', то должен быть указан 'Нормативный документ' и хотя бы одно из значений: 'Статья', 'Часть', 'Пункт', 'Подпункт'.</Описание>
<РезультатЗапроса>
{
local:getResult(
					for $td in $info/ТрудоваяДеятельность
						for $m in $td/Мероприятие
						where $m/Вид = '3'
							return if (
									local:existsAndNotEmpty($m/Сведения) 
								and (
										local:existsAndNotEmpty($m/Статья) 
									or (
											local:existsAndNotEmpty($m/ОснованиеУвольнения/УТ:НормативныйДокумент) 
										and (
												local:existsAndNotEmpty($m/ОснованиеУвольнения/УТ:Статья) 
											or 	local:existsAndNotEmpty($m/ОснованиеУвольнения/УТ:Часть) 
											or 	local:existsAndNotEmpty($m/ОснованиеУвольнения/УТ:Пункт) 
											or 	local:existsAndNotEmpty($m/ОснованиеУвольнения/УТ:Подпункт))))
								) then ()
							else local:result(
								local:nodePosition($m),
								'Не заполнены «Сведения о мероприятии» и либо «Номер статьи Трудового кодекса», либо «Основание увольнения» («Нормативный документ» и хотя бы одно из значений: «Статья», «Часть», «Пункт», «Подпункт»)',
								'СНИЛС, ФИО',
								concat($td/УТ:СНИЛС, ', ', local:getFIO($td/УТ:ФИО)))
				)}
</РезультатЗапроса>
<КодРезультата>50</КодРезультата>
</Проверка>
<Проверка ID="7">
<Описание>Если вид мероприятия принимает значение 'Переименование работодателя', то должны быть обязательно заполнены 'Сведения о мероприятии'</Описание>
<РезультатЗапроса>
{
local:getResult(
					for $td in $info/ТрудоваяДеятельность
						for $m in $td/Мероприятие
						where $m/Вид = '4'
							return if (local:existsAndNotEmpty($m/Сведения)) then ()
							else local:result(
								local:nodePosition($m),
								'Не заполнены «Сведения о мероприятии»',
								'СНИЛС, ФИО',
								concat($td/УТ:СНИЛС, ', ', local:getFIO($td/УТ:ФИО)))
				)}
</РезультатЗапроса>
<КодРезультата>50</КодРезультата>
</Проверка>
<Проверка ID="8">
<Описание>Если вид мероприятия принимает значение 'Служба в армии', то должны быть обязательно заполнены 'Сведения о мероприятии', 'Дата с', 'Дата по', а также 'Серия' документа-основания</Описание>
<РезультатЗапроса>
{
local:getResult(
					for $td in $info/ТрудоваяДеятельность
						for $m in $td/Мероприятие
						where $m/Вид = '5'
							return if (
									local:existsAndNotEmpty($m/Сведения)
								and local:existsAndNotEmpty($m/ДатаС)
								and local:existsAndNotEmpty($m/ДатаПо)
								and count($m/Основание) = count($m/Основание/Серия)
								) then ()
							else local:result(
								local:nodePosition($m),
								'Не заполнены «Сведения о мероприятии», «Дата с», «Дата по», а также «Серия» документа-основания',
								'СНИЛС, ФИО',
								concat($td/УТ:СНИЛС, ', ', local:getFIO($td/УТ:ФИО)))
				)}
</РезультатЗапроса>
<КодРезультата>50</КодРезультата>
</Проверка>
<Проверка ID="9">
<Описание>Если вид мероприятия принимает значение 'Образование', то должны быть обязательно заполнены 'Сведения о мероприятии', 'Должность', 'Дата по', а также 'Серия' документа-основания</Описание>
<РезультатЗапроса>
{
local:getResult(
					for $td in $info/ТрудоваяДеятельность
						for $m in $td/Мероприятие
						where $m/Вид = '6'
							return if (
									local:existsAndNotEmpty($m/Сведения)
								and local:existsAndNotEmpty($m/Должность)								
								and local:existsAndNotEmpty($m/ДатаПо)
								and count($m/Основание) = count($m/Основание/Серия)
								) then ()
							else local:result(
								local:nodePosition($m),
								'Не заполнены «Сведения о мероприятии», «Должность», «Дата по», а также «Серия» документа-основания',
								'СНИЛС, ФИО',
								concat($td/УТ:СНИЛС, ', ', local:getFIO($td/УТ:ФИО)))
				)}
</РезультатЗапроса>
<КодРезультата>50</КодРезультата>
</Проверка>
<Проверка ID="10">
<Описание>Если вид мероприятия принимает значение 'Обучение во время работы', то должны быть обязательно заполнены 'Сведения о мероприятии', 'Должность', 'Дата с', 'Дата по'</Описание>
<РезультатЗапроса>
{
local:getResult(
					for $td in $info/ТрудоваяДеятельность
						for $m in $td/Мероприятие
						where $m/Вид = '7'
							return if (
									local:existsAndNotEmpty($m/Сведения)
								and local:existsAndNotEmpty($m/Должность)								
								and local:existsAndNotEmpty($m/ДатаС)
								and local:existsAndNotEmpty($m/ДатаПо)					
								) then ()
							else local:result(
								local:nodePosition($m),
								'Не заполнены «Сведения о мероприятии», «Должность», «Дата с», «Дата по»',
								'СНИЛС, ФИО',
								concat($td/УТ:СНИЛС, ', ', local:getFIO($td/УТ:ФИО)))
				)}
</РезультатЗапроса>
<КодРезультата>50</КодРезультата>
</Проверка>
<Проверка ID="11">
<Описание>Если вид мероприятия принимает значение 'Награждение', то должны быть обязательно заполнены 'Сведения о мероприятии'</Описание>
<РезультатЗапроса>
{
local:getResult(
					for $td in $info/ТрудоваяДеятельность
						for $m in $td/Мероприятие
						where $m/Вид = '8'
							return if (local:existsAndNotEmpty($m/Сведения)) then ()
							else local:result(
								local:nodePosition($m),
								'Не заполнены «Сведения о мероприятии»',
								'СНИЛС, ФИО',
								concat($td/УТ:СНИЛС, ', ', local:getFIO($td/УТ:ФИО)))
				)}
</РезультатЗапроса>
<КодРезультата>50</КодРезультата>
</Проверка>
<Проверка ID="12">
<Описание>Если вид мероприятия принимает значение 'Установление второй и последующих профессий или разряда', то должны быть обязательно заполнены 'Сведения о мероприятии', 'Должность'</Описание>
<РезультатЗапроса>
{
local:getResult(
					for $td in $info/ТрудоваяДеятельность
						for $m in $td/Мероприятие
						where $m/Вид = '9'
							return if (
									local:existsAndNotEmpty($m/Сведения)
								and local:existsAndNotEmpty($m/Должность)	
								) then ()
							else local:result(
								local:nodePosition($m),
								'Не заполнены «Сведения о мероприятии», «Должность»',
								'СНИЛС, ФИО',
								concat($td/УТ:СНИЛС, ', ', local:getFIO($td/УТ:ФИО)))
				)}
</РезультатЗапроса>
<КодРезультата>50</КодРезультата>
</Проверка>
<Проверка ID="13">
<Описание>Если вид мероприятия принимает значение 'Исключение из непрерывного стажа', то должны быть обязательно заполнены 'Дата с', 'Дата по'</Описание>
<РезультатЗапроса>
{
local:getResult(
					for $td in $info/ТрудоваяДеятельность
						for $m in $td/Мероприятие
						where $m/Вид = '10'
							return if (															
									local:existsAndNotEmpty($m/ДатаС)
								and local:existsAndNotEmpty($m/ДатаПо)					
								) then ()
							else local:result(
								local:nodePosition($m),
								'Не заполнены «Дата с», «Дата по»',
								'СНИЛС, ФИО',
								concat($td/УТ:СНИЛС, ', ', local:getFIO($td/УТ:ФИО)))
				)}
</РезультатЗапроса>
<КодРезультата>50</КодРезультата>
</Проверка>
<Проверка ID="14">
<Описание>Если вид мероприятия принимает значение 'Восстановление непрерывного стажа', то должны быть обязательно заполнены 'Дата с', 'Дата по'</Описание>
<РезультатЗапроса>
{
local:getResult(
					for $td in $info/ТрудоваяДеятельность
						for $m in $td/Мероприятие
						where $m/Вид = '11'
							return if (															
									local:existsAndNotEmpty($m/ДатаС)
								and local:existsAndNotEmpty($m/ДатаПо)					
								) then ()
							else local:result(
								local:nodePosition($m),
								'Не заполнены «Дата с», «Дата по»',
								'СНИЛС, ФИО',
								concat($td/УТ:СНИЛС, ', ', local:getFIO($td/УТ:ФИО)))
				)}
</РезультатЗапроса>
<КодРезультата>50</КодРезультата>
</Проверка>
<Проверка ID="15">
<Описание>Если вид мероприятия принимает значение 'Запрет занимать должность', то должны быть обязательно заполнены 'Сведения о мероприятии', 'Дата по'</Описание>
<РезультатЗапроса>
{
local:getResult(
					for $td in $info/ТрудоваяДеятельность
						for $m in $td/Мероприятие
						where $m/Вид = '12'
							return if (
									local:existsAndNotEmpty($m/Сведения)					
								and local:existsAndNotEmpty($m/ДатаПо)					
								) then ()
							else local:result(
								local:nodePosition($m),
								'Не заполнены «Сведения о мероприятии», «Дата по»',
								'СНИЛС, ФИО',
								concat($td/УТ:СНИЛС, ', ', local:getFIO($td/УТ:ФИО)))
				)}
</РезультатЗапроса>
<КодРезультата>50</КодРезультата>
</Проверка>
<Проверка ID="16">
<Описание>Уникальный идентификатор мероприятия (UUID) не должен повторяться в пределах документа (исключение - UUID отменяемых мероприятий)</Описание>
<РезультатЗапроса>
{
local:getResult(
					for $uuid in $info/ТрудоваяДеятельность/Мероприятие/UUID
					where count(index-of($info/ТрудоваяДеятельность/Мероприятие/UUID, $uuid)) > 1 
					return local:result(local:nodePosition($uuid),concat('UUID = ', $uuid, ' не уникальный'),'','')
				)}
</РезультатЗапроса>
<КодРезультата>50</КодРезультата>
</Проверка>
</БлокПроверок>

