<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema" exclude-result-prefixes="xs УТ2 ns1 АФ5" version="1.0"
    xmlns:УТ2="http://пф.рф/УТ/2017-08-21" xmlns:АФ5="http://пф.рф/АФ/2018-12-07" xmlns:ns1="http://пф.рф/ЭТК/СЗВ-ТД/2017-10-08">
    <xsl:output method="html" indent="yes" encoding="utf-8"/>
    <xsl:include href="../Общие/УнифТипы_2017-08-21.xsl"/>
    <xsl:include href="../Общие/Базовые.xsl"/>
    <xsl:include href="ЭТК_2017-10-08.xsl"/>
    <xsl:include href="../Общие/ШтампЭП.xsl"/>
    <xsl:template match="/" name="inc">
        <div class="afWrap pfrAfSZV-TD">
            <h1 class="afHeader">Сведения о трудовой деятельности работников</h1>
            <p class="afInterval"/>
            
            <div class="afRow">
                <div class="afCol-2-5">Регистрационный номер в ПФР</div>
                <div class="afCol-1-2 afValue afUnderlinedAlignLeftPadding">
                    <xsl:value-of select="/ns1:ЭДПФР/ns1:СЗВ-ТД/ns1:Работодатель/УТ2:РегНомер"/>
                </div>
            </div>
            <div class="afRow">
                <div class="afCol-2-5">Наименование организации/индивидуального предпринимателя</div>
                <div class="afCol-1-2 afValue afUnderlinedAlignLeftPadding">
                    <xsl:value-of select="/ns1:ЭДПФР/ns1:СЗВ-ТД/ns1:Работодатель/ns1:НаименованиеОрганизации"/>
                </div>
            </div>
            <div class="afRow">
                <div class="afCol-2-5">ИНН</div>
                <div class="afCol-1-2 afValue afUnderlinedAlignLeftPadding">
                    <xsl:value-of select="/ns1:ЭДПФР/ns1:СЗВ-ТД/ns1:Работодатель/УТ2:ИНН"/>
                </div>
            </div>
            <div class="afRow">
                <div class="afCol-2-5">КПП</div>
                <div class="afCol-1-2 afValue afUnderlinedAlignLeftPadding">
                    <xsl:value-of select="/ns1:ЭДПФР/ns1:СЗВ-ТД/ns1:Работодатель/УТ2:КПП"/>
                </div>
            </div>                        
            <p class="afInterval"/>
            
            <div class="afRow">
                <div class="afC">Отчетный период</div>
                <div class="afCol-1-20 afValue afUnderlinedBlock">
                    <xsl:value-of select="/ns1:ЭДПФР/ns1:СЗВ-ТД/ns1:ОтчетныйПериод/ns1:Месяц"/>
                </div>
                <div class="afC">календарного года</div>
                <div class="afCol-1-20 afValue afUnderlinedBlock">
                    <xsl:value-of select="/ns1:ЭДПФР/ns1:СЗВ-ТД/ns1:ОтчетныйПериод/ns1:КалендарныйГод"/>
                </div>
            </div>
            <p class="afP afSmallSize">(01 – январь, 02 – февраль, 03 – март, 04 – апрель, 05 – май, 06 – июнь, 07 – июль, 08 – август, 09 – сентябрь, 10 – октябрь, 11 – ноябрь, 12 – декабрь)</p>
            <p class="afInterval"/>
            
            <table class="afTable afSmallSize">
                <thead>
                    <tr class="afCenter">
                        <td rowspan="3">№ п/п</td>
                        <td rowspan="3">Фамилия</td>
                        <td rowspan="3">Имя</td>
                        <td rowspan="3">Отчество</td>
                        <td rowspan="3">СНИЛС</td>
                        <td colspan="8">Сведения о трудовой деятельности работников</td>
                    </tr>
                    <tr class="afCenter">
                        <td rowspan="2">Дата (число, месяц, год) приема, перевода, приостановления, увольнения</td>
                        <td rowspan="2">Вид мероприятия (прием, перевод, приостановление, увольнение)</td>
                        <td colspan="3">Наименование</td>
                        <td colspan="3">Основание</td>                        
                    </tr>
                    <tr class="afCenter">
                        <td>Должность, специальность, профессия, квалификация</td>
                        <td>Структурное подразделение</td>
                        <td>Статья, пункт федерального закона, причины при увольнении</td>
                        <td>Наименование документа</td>
                        <td>Дата</td>
                        <td>Номер документа</td>
                    </tr>
                    <tr class="afCenter">
                        <td>1</td>
                        <td>2</td>
                        <td>3</td>
                        <td>4</td>
                        <td>5</td>
                        <td>6</td>
                        <td>7</td>
                        <td>8</td>
                        <td>9</td>
                        <td>10</td>
                        <td>11</td>
                        <td>12</td>
                        <td>13</td>
                    </tr>
                </thead>                
                <tbody>
                    <xsl:for-each select="/ns1:ЭДПФР/ns1:СЗВ-ТД/ns1:ТрудоваяДеятельность/ns1:Мероприятие">
                        <xsl:variable name="docCount" select="count(ns1:Основание)"/>
                        <tr class="afValue">
                            <td rowspan="{$docCount}"><xsl:value-of select="position()"/></td>
                            <td rowspan="{$docCount}"><xsl:value-of select="../УТ2:ФИО/УТ2:Фамилия"/></td>
                            <td rowspan="{$docCount}"><xsl:value-of select="../УТ2:ФИО/УТ2:Имя"/></td>
                            <td rowspan="{$docCount}"><xsl:value-of select="../УТ2:ФИО/УТ2:Отчество"/></td>
                            <td rowspan="{$docCount}"><xsl:value-of select="../УТ2:СНИЛС"/></td>
                            <td rowspan="{$docCount}">
                                <xsl:call-template name="Date2GOST">
                                    <xsl:with-param name="pDate" select="ns1:Дата"/>
                                    <xsl:with-param name="pNoUnderline" select="1"/>
                                </xsl:call-template>
                            </td>
                            <td rowspan="{$docCount}">
                                <xsl:call-template name="TypeEventStr">
                                    <xsl:with-param name="pTypeEvent" select="ns1:Вид"/>
                                </xsl:call-template>
                                <xsl:if test="ns1:ЯвляетсяСовместителем = '1' or ns1:ЯвляетсяСовместителем = 'true'">
                                    . По совместительству
                                </xsl:if>
                            </td>
                            <td rowspan="{$docCount}"><xsl:value-of select="ns1:Должность"/></td>
                            <td rowspan="{$docCount}"><xsl:value-of select="ns1:СтруктурноеПодразделение"/></td>
                            <td rowspan="{$docCount}">
                                <xsl:call-template name="DismissalStr">
                                    <xsl:with-param name="pEvent" select="."/>
                                </xsl:call-template>   
                            </td>
                            <td><xsl:value-of select="ns1:Основание[1]/ns1:Наименование"/></td>
                            <td>
                                <xsl:call-template name="Date2GOST">
                                    <xsl:with-param name="pDate" select="ns1:Основание[1]/ns1:Дата"/>
                                    <xsl:with-param name="pNoUnderline" select="1"/>
                                </xsl:call-template>
                            </td>
                            <td><xsl:value-of select="ns1:Основание[1]/ns1:Номер"/></td>
                        </tr>
                        <xsl:if test="ns1:Основание[2]">
                            <tr class="afValue">
                                <td><xsl:value-of select="ns1:Основание[2]/ns1:Наименование"/></td>
                                <td>
                                    <xsl:call-template name="Date2GOST">
                                        <xsl:with-param name="pDate" select="ns1:Основание[2]/ns1:Дата"/>
                                        <xsl:with-param name="pNoUnderline" select="1"/>
                                    </xsl:call-template>
                                </td>
                                <td><xsl:value-of select="ns1:Основание[2]/ns1:Номер"/></td>
                            </tr>
                        </xsl:if>                        
                    </xsl:for-each>                    
                </tbody>
            </table>
            <p class="afInterval"/>

            <div class="afNoBreakBefore afNoBreakInside">
                <div class="afSign">
                    <div class="afPadding">
                        <p class="afUnderlinedBlock afValue">
                            <xsl:value-of select="/ns1:ЭДПФР/ns1:СЗВ-ТД/ns1:Руководитель/УТ2:Должность"/>
                        </p>
                        <p class="afSubscript afCenter">Наименование должности руководителя</p>
                    </div>
                    <div class="afPadding">
                        <p class="afBlankUnderlinedBlock"/>
                        <p class="afSubscript afCenter">(Подпись)</p>
                    </div>
                    <div class="afPadding">
                        <p class="afUnderlinedBlock afValue">
                            <xsl:call-template name="УТ2:NameStr">
                                <xsl:with-param name="pName" select="/ns1:ЭДПФР/ns1:СЗВ-ТД/ns1:Руководитель/УТ2:ФИО"/>
                            </xsl:call-template>
                        </p>
                        <p class="afSubscript afCenter">(Ф.И.О.)</p>
                    </div>
                </div>
                <p class="afInterval"/>

                <div class="afRow">                    
                    <div class="afCol-1-4 afPadding">
                        <div class="afUnderlinedBlock afValue">
                            <xsl:call-template name="Date2Text">
                                <xsl:with-param name="pDate" select="/ns1:ЭДПФР/ns1:СЗВ-ТД/ns1:ДатаПередачи"/>
                            </xsl:call-template>
                            г.
                        </div>
                        <p class="afSubscript afCenter">(дата)</p>
                    </div>                    
                </div>
            </div>
            
            <xsl:if test="/ns1:ЭДПФР/ns1:СлужебнаяИнформация/АФ5:РеквизитыЭП">
                <xsl:call-template name="PrintSignature">
                    <xsl:with-param name="pSignature" select="/ns1:ЭДПФР/ns1:СлужебнаяИнформация/АФ5:РеквизитыЭП" />
                </xsl:call-template>
            </xsl:if>
        </div>
    </xsl:template>

    <!-- Вид мероприятия -->
    <xsl:template name="TypeEventStr">
        <xsl:param name="pTypeEvent"/>
        <xsl:choose>
            <xsl:when test="$pTypeEvent = '1'">Прием на работу</xsl:when>
            <xsl:when test="$pTypeEvent = '2'">Перевод</xsl:when>
            <xsl:when test="$pTypeEvent = '3'">Увольнение</xsl:when>
            <xsl:when test="$pTypeEvent = '4'">Переименование работодателя</xsl:when>
            <xsl:when test="$pTypeEvent = '5'">Служба в армии</xsl:when>
            <xsl:when test="$pTypeEvent = '6'">Образование</xsl:when>
            <xsl:when test="$pTypeEvent = '7'">Обучение во время работы (курсы повышения квалификации, переквалификации и подготовки кадров)</xsl:when>
            <xsl:when test="$pTypeEvent = '8'">Награждение</xsl:when>
            <xsl:when test="$pTypeEvent = '9'">Установление второй и последующих профессий или разряда</xsl:when>
            <xsl:when test="$pTypeEvent = '10'">Исключение из непрерывного стажа</xsl:when>
            <xsl:when test="$pTypeEvent = '11'">Восстановление непрерывного стажа</xsl:when>
            <xsl:when test="$pTypeEvent = '12'">Запрет занимать должность</xsl:when>            
        </xsl:choose>
    </xsl:template>

</xsl:stylesheet>
